import java.awt.*;
import java.util.Vector;
import java.util.Random;
import java.io.*;
import java.net.*;

import ma.game.*;

class TMalo 
{
	public int X,Y,Ini,Fin,Im,P0,P1,V;                 
}

class TBufferTesoros
{
	public int Tesoros;
	public int[] Tiles1={0,0,0,0};
	public int[] Tiles2={0,0,0,0};
}

public class TJuego extends TEscenario
{	
	protected Image miScreen;
	protected Image miSprites;
	protected Image miDecorados;
	protected Image miPanel;	
	protected TFont miFont,miFont1;

	protected int[] Cosa	 = {0,28,29,30,29,0,0,0,0,0,0};
	protected int[] Aro   = {0,42,43,44,45,0,0,0,0,0,0};
	protected int[] Arana = {0,25,26,27,26,0,0,0,0,0,0};
	protected int[] Tabla = {0,61,61,61,62,63,64,65,66,0,0};
	protected int[] Bola  = {0,67,68,69,70,71,70,69,68,0,0};
	protected int[] Pelota= {0,39,40,41,40,0,0,0,0,0,0};
	protected int[] Rayo  = {0,46,47,48,47,49,47,0,0,0,0};
	protected int[] Flecha= {0,50,51,52,51,0,0,0,0,0,0};
	protected int[] SerDe = {0,22,23,24,23,0,0,0,0,0,0};
	protected int[] SerIz = {0,19,20,21,20,0,0,0,0,0,0};
	protected int[] PezUp = {0,53,54,55,53,0,0,0,0,0,0};
	protected int[] PezDo = {0,56,57,58,57,0,0,0,0,0,0};
	protected int[] MomDe = {0,31,32,33,34,0,0,0,0,0,0};
	protected int[] MomIz = {0,35,36,37,38,0,0,0,0,0,0};
	protected int[] Lanza = {0,59,0,0,0,0,0,0,0,0,0};
	protected int[] Unde  = {0,72,73,74,75,76,77,78,79,0,0};
	protected int[] Lapida= {0,80,81,82,83,84,85,86,87,79,0};
	protected int[] Jonhy = {1,2,1,3,1,4,0,0,0,0};

	// Color de la Puerta.
	protected int[] ColorPuerta = {393,394,395,396,397,0,0,0,0,0};
	int i_ColorPuerta;
	
	// Mapeado
	protected int[] Mapeado = new int[23040];

	// Los Malos
	TMalo Enemigos[][]=new TMalo[45][3];		// Contiene las posiciones de todos los malos.
	TMalo Ene[]=new TMalo[3];							// Contiene las posiciones de los 3 malos de una pantalla.
	
	// Variables del Juego	
	protected int i_PantallaActual=-1;
	protected int i_Vidas=16;
	protected int i_Tesoros=0;
	protected boolean ib_derecha=false;
	protected boolean ib_izquierda=false;
	protected boolean ib_salto_largo=false;
	protected boolean ib_salto_corto=false;
	protected TBufferTesoros BuffTesoros = new TBufferTesoros();

	// Variables Iniciales del Personaje.
	protected int Spx=30+5*8;
	protected int Spy=13*8;
	protected int MSpx,MSpy;
	protected int DesplazaX=2;
	protected int DesplazaY=2;
	
	// Seno para el GameOver..
	protected int i_seno[] = new int[320];
	protected int i_senobuff[] = new int[5];

	public void init()
	{
		String ls_path = "pics/";			  	  
		
		// Establecemos color de fondo.
    maGame.i_gameCanvas.setSurfaceBackground(new Color(0,0,0));
    maGame.i_gameCanvas.clear();	
	  
	  // Creamos el Font
	  miFont = new TFont(ls_path+"Fonts.gif",8,8,"ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789()>,");
	  miFont1 =new TFont(ls_path+"GameOver.gif",25,30,"GAMEOVR");

    // Creamos el Buffer para dibujar pantallas.
    miScreen = maGame.createImage(256,128);
		
    // Cargamos los grficos del Juego.		
		maGame.getTracker().Reset();
		miPanel = maGame.LoadImage(ls_path+"Panel1.gif");
		miSprites = maGame.LoadImage(ls_path+"Sprites.gif");
		miDecorados = maGame.LoadImage(ls_path+"Deco.gif");		
		maGame.getTracker().AddWaitImage(miPanel);
		maGame.getTracker().AddWaitImage(miSprites);
		maGame.getTracker().AddWaitImage(miDecorados);    
		maGame.getTracker().WaitImages();
		maGame.setGameSpeed(100);
		
		cargaMapeado();
		cargaEnemigos();
		BuffTesoros.Tesoros=0;
		
		Random r=new Random();
		int color = Math.abs(r.nextInt()) % 5;
		if (color<0 || color>4) color=2;
		i_ColorPuerta=ColorPuerta[color];
	  
	  // Inicializamos la tabla de Seno.
		
		double delta=(1*3.14)/320;
		double inc=0;		
		for (int i=0;i<320;i++)
		{
			i_seno[i]=(int)(8*Math.sin(inc));
			inc+=delta;
		}

	  
	  PasaPantalla(1,Spx,Spy);	  
  	super.init();  
	}
	
	protected void cargaMapeado()
	{
			InputStream is=null;
			try
			{
			 // Intentamos hacer abrir el fichero desde un applet.
			 is = new URL(maGame.getDocumentBase(), "data/pics/Maze.dat").openStream();			
			}
			catch (Exception e) 
			{			
			 // Intentamos hacer la carga desde la shell.
			 try{
			 	is = new FileInputStream("pics/Maze.dat");
			 }
			 catch (Exception e1) {System.out.println("Error Mapa 1: " + e1); }
			}
			if (is==null) System.out.println("Error al abrir fichero de Mapeado.");
			else
			{
				int pos=0;
				try{
					while (pos<23040)
					{
						int lo=is.read();
						int hi=is.read();
						Mapeado[pos++]=hi*256+lo;
					}
					is.close();
				}
				catch(Exception e2) { System.out.println("Error Mapa 1: " + e2);  }
				
			}
			
	}
	
	protected void cargaEnemigos()
	{
		
		InputStream is=null;
		for (int i=0;i<3;i++) Ene[i]=new TMalo();
		for (int i=0;i<45;i++) for(int j=0;j<3;j++) Enemigos[i][j]=new TMalo();
		
		try
		{
		 // Intentamos hacer abrir el fichero desde un applet.
		 is = new URL(maGame.getDocumentBase(), "data/pics/Bad.dat").openStream();			
		}
		catch (Exception e) 
		{			
		 // Intentamos hacer la carga desde la shell.
		 try{
		 	is = new FileInputStream("pics/Bad.dat");
		 }
		 catch (Exception e1) {}
		}
		if (is==null) System.out.println("Error al abrir fichero de Enemigos.");
		else
		{
			int pos=0;
			try{
				for (int i=0;i<45;i++) for(int j=0;j<3;j++) 
				{
					Enemigos[i][j].X = is.read()+is.read()*256;
					Enemigos[i][j].Y = is.read()+is.read()*256;
					Enemigos[i][j].Ini = is.read()+is.read()*256;
					Enemigos[i][j].Fin = is.read()+is.read()*256;
					Enemigos[i][j].Im = is.read()+is.read()*256;
					Enemigos[i][j].P0 = is.read()+is.read()*256;
					Enemigos[i][j].P1 = is.read()+is.read()*256;
					Enemigos[i][j].V = is.read()+is.read()*256;					
				}
				is.close();
			}
			catch(Exception e2) {}
			
		}
	}
	
	protected void RellenaMapa(int X,int Y,int Ax,int Ay,int C,int scr)
	{
		int A,B;
		if (scr<0) scr=i_PantallaActual;
	
		for (A=Y;A<Y+Ay;A++)
		for (B=X;B<X+Ax;B++)
		{
			Mapeado[scr*512+A*32+B]=C;
		}
	}
		
	protected void DrawScreen(Graphics dest,int scr)
	{
		int x,y;
	
		if (scr==9) RellenaMapa(25,11,4,2,i_ColorPuerta,9);
	
		int offset = scr*512;
		for (y=0;y<16;y++) {
			for (x=0;x<32;x++) {
				PutDecoTile(dest,x,y,Mapeado[offset++]);
			}
		}
	
		switch (scr)
		{
		case 9:
			PutDecoTile(dest,25,6,426);
			break;
		
		case 43:
			PutDecoTile(dest,11,3,427);
			break;
		}
	}

	protected void PutDecoTile(Graphics dest,int x,int y,int index)
	{
		Rectangle lRect=new Rectangle();
		index--;
	
		if (index<425) 
		{
			lRect.x = (index % 25)*8;
			lRect.y = (index / 25)*8;
			lRect.width = lRect.x + 8;
			lRect.height = lRect.y + 8;
			dest.drawImage(miDecorados,x*8, y*8,x*8+8,y*8+8, lRect.x,lRect.y,lRect.width,lRect.height, null);	    
		}
		else if (index==425)
		{
			lRect.x = 219;		lRect.y= 98;
			lRect.width = 219+32;	lRect.height= 98+32;		
			dest.drawImage(miDecorados,x*8, y*8,x*8+32,y*8+32, lRect.x,lRect.y,lRect.width,lRect.height, null);	    
		}
		else if (index==426)
		{
			lRect.x = 220;		lRect.y = 5;
			lRect.width = 220+64;	lRect.height = 5+88;
			dest.drawImage(miDecorados,x*8, y*8,x*8+64,y*8+88, lRect.x,lRect.y,lRect.width,lRect.height, null);
		}
		
	}
	
	// ******************************************
	//        Manejadores de los Sonidos
	// ******************************************

	void SuenaGota(){}	
	void SuenaRoca(){}
	void SuenaPuerta(){}
	void SuenaCoger(){}

	// ******************************************
	//        Manejadores de los personajes
	// ******************************************
			  
	void ObjHor(Graphics buff,int S,int[] Movy)
	{
	 if (Ene[S].X<=Ene[S].Ini || Ene[S].X>=Ene[S].Fin) Ene[S].V=-Ene[S].V;
	 Ene[S].X+=Ene[S].V;
	 if (Movy[Ene[S].Im]==0) Ene[S].Im=1;
	 PutSprite(buff,Movy[Ene[S].Im],Ene[S].X,Ene[S].Y);
	 
	 if (Ene[S].P0==Ene[S].P1)
	 {
	  Ene[S].Im++;
	  Ene[S].P0=1;
	 }
	 
	 // CountUp(Ene[S].P0,1,1,Ene[S].P1);
	 Ene[S].P0++;
	 if (Ene[S].P0<1 || Ene[S].P0>Ene[S].P1) Ene[S].P0=1;
	 // Fin CountUp	 
	}

	void ObjVer(Graphics buff,int S,int[] Movy)
	{
	 if (Ene[S].Y<=Ene[S].Ini || Ene[S].Y>=Ene[S].Fin) Ene[S].V=-Ene[S].V;
	 Ene[S].Y+=Ene[S].V;
	 if (Movy[Ene[S].Im]==0) Ene[S].Im=1;
	 PutSprite(buff,Movy[Ene[S].Im],Ene[S].X,Ene[S].Y);
	
	 if (Ene[S].P0==Ene[S].P1)
	 {
	  Ene[S].Im++;
	  Ene[S].P0=1;
	 }
	 
	 // CountUp(Ene[S].P0,1,1,Ene[S].P1);
	 Ene[S].P0++;
	 if (Ene[S].P0<1 || Ene[S].P0>Ene[S].P1) Ene[S].P0=1;
	 // Fin CountUp	 
	}

	void ObjHor1(Graphics buff,int S,int[] Movy0,int[] Movy1)
	{
		int[] Movy;
		
		if (Ene[S].X<=Ene[S].Ini || Ene[S].X>=Ene[S].Fin) Ene[S].V=-Ene[S].V;
		if (Ene[S].V>0) Movy=Movy0; else Movy=Movy1;
		Ene[S].X+=Ene[S].V;
		
		if (Movy[Ene[S].Im]==0) Ene[S].Im=1;
		
		PutSprite(buff,Movy[Ene[S].Im],Ene[S].X,Ene[S].Y);
		if (Ene[S].P0==Ene[S].P1)
		{
			Ene[S].Im++;
			Ene[S].P0=1;
		}
		
		// CountUp(Ene[S].P0,1,1,Ene[S].P1);
		Ene[S].P0++;
		if (Ene[S].P0<1 || Ene[S].P0>Ene[S].P1) Ene[S].P0=1;
		// Fin CountUp
	}

	void ObjVer1(Graphics buff,int S,int[] Movy0,int[] Movy1)
	{
	 	int[] Movy;
	
		if (Ene[S].Y<=Ene[S].Ini || Ene[S].Y>=Ene[S].Fin) Ene[S].V=-Ene[S].V;
		if (Ene[S].V>0) Movy=Movy0; else Movy=Movy1;
		Ene[S].Y+=Ene[S].V;
		if (Movy[Ene[S].Im]==0) Ene[S].Im=1;
		PutSprite(buff,Movy[Ene[S].Im],Ene[S].X,Ene[S].Y);
		if (Ene[S].P0==Ene[S].P1)
		{
		  Ene[S].Im++;
		  Ene[S].P0=1;
		}
	 // CountUp(Ene[S].P0,1,1,Ene[S].P1);
	 Ene[S].P0++;
	 if (Ene[S].P0<1 || Ene[S].P0>Ene[S].P1) Ene[S].P0=1;
	 // Fin CountUp	 
	}

	void Horizontal(Graphics buff,int S,int[] Movy)
	{
	 if (Ene[S].X>=Ene[S].Fin) Ene[S].X=Ene[S].Ini;
	 Ene[S].X+=Ene[S].V;
	 if (Movy[Ene[S].Im]==0) Ene[S].Im=1;
	 PutSprite(buff,Movy[Ene[S].Im],Ene[S].X,Ene[S].Y);
	 if (Ene[S].P0==Ene[S].P1)
	 {
	  Ene[S].Im++;
	  Ene[S].P0=1;
	 }
	 // CountUp(Ene[S].P0,1,1,Ene[S].P1);
	 Ene[S].P0++;
	 if (Ene[S].P0<1 || Ene[S].P0>Ene[S].P1) Ene[S].P0=1;
	 // Fin CountUp	 
	}

	void Gota(Graphics buff,int Ima,int S)
	{
		if (Ene[S].Y<Ene[S].Ini) Ene[S].Y=Ene[S].Ini;
	
		if (Ene[S].Y<Ene[S].Fin)
		{
			Ene[S].Y=Ene[S].Y+Ene[S].V; Ene[S].Im=Ima;
			PutSprite(buff,Ene[S].Im,Ene[S].X,Ene[S].Y);
		}
		else
		{
			if (Ene[S].Im<18) 
			{
				// CountUp
				Ene[S].Im++;
				if (Ene[S].Im<16 || Ene[S].Im>18) Ene[S].Im=16;
				// Fin COuntup
				
				if (Ene[S].Im==16) SuenaGota();
				PutSprite(buff,Ene[S].Im,Ene[S].X,Ene[S].Fin);
			}
			else
			if (Ene[S].Im>18 && Ene[S].Im<92)
			{
				// CountUp
				Ene[S].Im++;
				if (Ene[S].Im<88 || Ene[S].Im>92) Ene[S].Im=88;
	 			// Fin CountUp	 

				if (Ene[S].Im==88) SuenaRoca();
				PutSprite(buff,Ene[S].Im,Ene[S].X,Ene[S].Fin);
			}
			else
			{
				Ene[S].Im=Ima;
				Ene[S].Y=Ene[S].Ini;		
			}
		}
	}	
	
	void PutSprite(Graphics dest,int spr,int x,int y)
	{
		spr--;	
		int x1 = (spr % 19)*16;
		int y1 = (spr / 19)*16;		
		dest.drawImage(miSprites,x,y,x+16,y+16,x1,y1,x1+16,y1+16,null);
	}
	
	// ***********************************
	//    MANEJADORES DE LAS PANTALLAS 
	// ***********************************
	
	public void draw(Graphics g)
	{
		if (i_PantallaActual<0) return;
		if (i_Estado==1000) 
		{
			// Abortamos el Juego
			maGame.setStartClass("TPresentacion");
			maGame.startClass();
			return;
		}
		
		maGame.i_gameCanvas.clear();	
 		
		switch (i_Estado)
		{
		case 0:
			DrawScreen(miScreen.getGraphics(),i_PantallaActual);
			MSpx=Spx;
			MSpy=Spy;
			
			// Establece las posiciones de los bichitos..
			for (int i=0;i<3;i++)
			{
				Ene[i].X = Enemigos[i_PantallaActual][i].X;
				Ene[i].Y = Enemigos[i_PantallaActual][i].Y;
				Ene[i].Ini = Enemigos[i_PantallaActual][i].Ini;
				Ene[i].Fin = Enemigos[i_PantallaActual][i].Fin;
				Ene[i].Im = Enemigos[i_PantallaActual][i].Im;
				Ene[i].P0 = Enemigos[i_PantallaActual][i].P0;
				Ene[i].P1 = Enemigos[i_PantallaActual][i].P1;
				Ene[i].V = Enemigos[i_PantallaActual][i].V;
			}			
			
			Ene[0].P0=Ene[0].P1;
			Ene[1].P0=Ene[1].P1;
			Ene[2].P0=Ene[2].P1;
			
			// Correccin en algunos datos de los personajes.
			switch (i_PantallaActual+1)
			{
			case 7:
				Ene[1].V--;	// Reducimos la velocidad del Aro
				break;
	
			case 8:
				Ene[1].V--;	// Reducimos la velodiad de la gota.
				break;
	
			case 25:
				Ene[1].Ini+=14; // Bajamos la Altura de la Flecha.
				Ene[1].Y=Ene[1].Ini+1;
				Ene[1].V=1;
				break;
	
			case 37:
				Ene[2].X=86; Ene[2].Y=24;
				Ene[2].V=2; Ene[2].P0=-3;
				Ene[2].Im=Bola[1];
				break;
			}

			i_Estado++;	              
			break;

		}
		
		g.drawImage(miPanel,0,129,null);
 		miFont.drawText("PANTALLA "+(i_PantallaActual+1)+" VIDAS "+i_Vidas,-1,130);
 		g.drawImage(miScreen,30,0,null);   
 		
		// Pinta los tesoros en caso de que haya..
		if (BuffTesoros.Tesoros>0)
		{
			PutDecoTile(g,17,19,BuffTesoros.Tiles1[0]);
			PutDecoTile(g,18,19,BuffTesoros.Tiles1[1]);
			PutDecoTile(g,17,20,BuffTesoros.Tiles1[2]);
			PutDecoTile(g,18,20,BuffTesoros.Tiles1[3]);
		}
	
		if (BuffTesoros.Tesoros>1)
		{
			PutDecoTile(g,20,19,BuffTesoros.Tiles2[0]);
			PutDecoTile(g,21,19,BuffTesoros.Tiles2[1]);
			PutDecoTile(g,20,20,BuffTesoros.Tiles2[2]);
			PutDecoTile(g,21,20,BuffTesoros.Tiles2[3]);
		}
 		
 		// --------- PONEMOS LOS BICHITOS
 		
 		switch (i_PantallaActual)
		{
			case 0:
				drawPantalla1(g);
				break;
			case 1:
				drawPantalla2(g);
				break;
			case 2:
				drawPantalla3(g);
				break;
			case 3:
				drawPantalla4(g);
				break;
			case 4:
				drawPantalla5(g);
				break;
			case 5:
				drawPantalla6(g);
				break;
			case 6:
				drawPantalla7(g);
				break;
			case 7:
				drawPantalla8(g);
				break;
			case 8:
				drawPantalla9(g);
				break;
			case 9:
				drawPantalla10(g);
				break;
			case 10:
				drawPantalla11(g);
				break;
			case 11:
				drawPantalla12(g);
				break;
			case 12:
				drawPantalla13(g);
				break;
			case 13:
				drawPantalla14(g);
				break;
			case 14:
				drawPantalla15(g);
				break;
			case 15:
				drawPantalla16(g);
				break;
			case 16:
				drawPantalla17(g);
				break;
			case 17:
				drawPantalla18(g);
				break;
			case 18:
				drawPantalla19(g);
				break;
			case 19:
				drawPantalla20(g);
				break;
			case 20:
				drawPantalla21(g);
				break;
			case 21:
				drawPantalla22(g);
				break;
			case 22:
				drawPantalla23(g);
				break;
			case 23:
				drawPantalla24(g);
				break;
			case 24:
				drawPantalla25(g);
				break;
			case 25:
				drawPantalla26(g);
				break;
			case 26:
				drawPantalla27(g);
				break;
			case 27:
				drawPantalla28(g);
				break;
			case 28:
				drawPantalla29(g);
				break;
			case 29:
				drawPantalla30(g);
				break;
			case 30:
				drawPantalla31(g);
				break;
			case 31:
				drawPantalla32(g);
				break;
			case 32:
				drawPantalla33(g);
				break;
			case 33:
				drawPantalla34(g);
				break;
			case 34:
				drawPantalla35(g);
				break;
			case 35:
				drawPantalla36(g);
				break;
			case 36:
				drawPantalla37(g);
				break;
			case 37:
				drawPantalla38(g);
				break;
			case 38:
				drawPantalla39(g);
				break;
			case 39:
				drawPantalla40(g);
				break;
			case 40:
				drawPantalla41(g);
				break;
			case 41:
				drawPantalla42(g);
				break;
			case 42:
				drawPantalla43(g);
				break;
			case 43:
				drawPantalla44(g);
				break;
			case 44:
				drawFinal(g);
				break;
		}
	}	
	
	void PasaPantalla(int F,int X,int Y)
	{
		i_Estado=0;
		i_PantallaActual=F-1;
		Spx=X;
		Spy=Y;
	}
	
	void drawPantalla1(Graphics buff)
	{
		Gota(buff,15,0);
	  ObjHor(buff,1,Cosa);
	  ObjVer(buff,2,Tabla);
	  SpritePrincipal(buff);
		
		if (Spx>=270) PasaPantalla(2,32,Spy);	
		ElTesoro(190,104,22,13,1,1,i_ColorPuerta,0,false,true);
	}
	
	void drawPantalla2(Graphics buff)
	{
		ObjHor(buff,0,Bola);
		ObjHor1(buff,1,SerDe,SerIz);
	  ObjVer(buff,2,Flecha);
		SpritePrincipal(buff);	
		if (Spx<=30) PasaPantalla(1,268,Spy);
		if (Spy>=112) PasaPantalla(3,Spx,0);
	}

	void drawPantalla3(Graphics buff)
	{
		ObjHor(buff,0,Flecha);
		ObjHor(buff,1,Arana);
		ObjHor1(buff,2,MomDe,MomIz);
		SpritePrincipal(buff);
		if (Spy<0) PasaPantalla(2,Spx,110);
	  if (Spy>=112) PasaPantalla(4,Spx,0);
	}

	void drawPantalla4(Graphics buff)
	{
		Gota(buff,15,0);
		ObjVer(buff,1,Tabla);
		ObjHor1(buff,2,SerDe,SerIz);
		SpritePrincipal(buff);		
		if (Spy<0) PasaPantalla(3,Spx,110);
		if (Spx>=270) PasaPantalla(5,56,Spy);
		if (Spy>=112) PasaPantalla(7,Spx,0);
		ElTesoro(60,40,28,10,3,3,1,1,true,false);
	}

	void drawPantalla5(Graphics buff)
	{
		Gota(buff,15,0);
		ObjVer(buff,1,Arana);
		Gota(buff,15,2);
		SpritePrincipal(buff);
	
		if (Spx>=270) PasaPantalla(6,32,Spy);
	}

	void drawPantalla6(Graphics buff)
	{
		Gota(buff,15,0);
		ObjHor(buff,1,Pelota);
		ObjHor1(buff,2,MomDe,MomIz);
		SpritePrincipal(buff);
	
		if (Spx<=30) PasaPantalla(5,268,Spy);
		if (Spx>=270) PasaPantalla(4,182,16);
	    
		ElTesoro(222,48,26,10,5,3,1,2,true,true);
	}

	void drawPantalla7(Graphics buff)
	{
		ObjHor(buff,0,Bola);
		ObjHor(buff,1,Aro);
		ObjVer(buff,2,Cosa);
		SpritePrincipal(buff);
	
		if (Spy<0) PasaPantalla(4,Spx,110);
	  if (Spx>=270) PasaPantalla(8,32,Spy);
	}
	
	void drawPantalla8(Graphics buff)
	{
		ObjHor(buff,0,Bola);
	  Gota(buff,15,1);
		ObjHor(buff,2,Arana); 
		SpritePrincipal(buff);
	
		if (Spx>=270) PasaPantalla(9,48,Spy);
	  if (Spx<=30) PasaPantalla(7,268,Spy);
	  ElTesoro(216,88,28,2,3,3,1,3,true,true);
	}
	
	void drawPantalla9(Graphics buff)
	{
		ObjHor(buff,0,Tabla);
		ObjHor(buff,1,Arana);
		ObjHor(buff,2,Bola);  
		SpritePrincipal(buff);
	
		if (Spx>=270) PasaPantalla(10,32,Spy);
	  ElTesoro(86,96,18,2,3,5,1,4,true,false);
	}
	
	void drawPantalla10(Graphics buff)
	{
		ObjHor1(buff,0,SerDe,SerIz);
		Gota(buff,15,1);
		ObjVer(buff,2,Arana); 
		SpritePrincipal(buff);
	
		if (Spx<=30) PasaPantalla(9,268,Spy);
	  if (Spy<0) PasaPantalla(11,Spx,110);
	}

	void drawPantalla11(Graphics buff)
	{
		ObjVer(buff,0,Rayo);
		Gota(buff,15,1);
		ObjVer(buff,2,Pelota);
		SpritePrincipal(buff);
	
		if (Spy>=112) PasaPantalla(10,Spx,0);
	  if (Spy<0) PasaPantalla(12,Spx,110);
	}
	
	void drawPantalla12(Graphics buff)
	{
		Gota(buff,15,0);
		ObjHor(buff,1,Aro);
		ObjHor(buff,2,Cosa);
		SpritePrincipal(buff);
	
		if (Spy>=112) PasaPantalla(11,Spx,0);
		ElTesoro(214,32,23,2,1,1,i_ColorPuerta,5,false,true);
		ElTesoro(94,24,15,2,5,9,1,6,true,false);
		if (i_Tesoros==7 && Mapeado[12*512+2*32+15]==1) PasaPantalla(13,230,96);
	}
	
	void drawPantalla13(Graphics buff)
	{
		Gota(buff,15,0); 
		ObjVer(buff,1,Arana); 
		Gota(buff,15,2);
		SpritePrincipal(buff);
	
		if (Spx<=30) PasaPantalla(14,268,Spy);
	}
	
	void drawPantalla14(Graphics buff)
	{
		ObjHor1(buff,0,SerDe,SerIz);
		ObjHor1(buff,1,SerDe,SerIz);
		ObjHor1(buff,2,SerDe,SerIz);               
		SpritePrincipal(buff);
	
		if (Spx>=270) PasaPantalla(13,32,Spy);
		if (Spx<=30) PasaPantalla(15,268,Spy);
	}
	
	void drawPantalla15(Graphics buff)
	{
		Gota(buff,15,0); 
		ObjVer(buff,1,Arana); 
		ObjHor(buff,2,Flecha);
		SpritePrincipal(buff);
	
		if (Spx>=270) PasaPantalla(14,32,Spy);
		if (Spy>=112) PasaPantalla(16,Spx,0);
	}
	
	void drawPantalla16(Graphics buff)
	{
		ObjHor(buff,0,Arana); 
		ObjHor(buff,1,Cosa); 
		Gota(buff,15,2);
		SpritePrincipal(buff);
	
		if (Spx>=270) PasaPantalla(17,78,Spy);
		if (Spx>140 && Spx<260) ElTesoro(Spx,32,26,4,5,9,1,7,true,true);
	
	}
	
	void drawPantalla17(Graphics buff)
	{
		Gota(buff,15,0); 
		Gota(buff,15,1); 
		Gota(buff,15,2);
		SpritePrincipal(buff);
	
		if (Spx>200) ElTesoro(Spx,Spy,25,11,1,1,i_ColorPuerta,8,false,false);
	    if (i_Tesoros==9) PasaPantalla(18,38,16);
	}
	
	void drawPantalla18(Graphics buff)
	{
		ObjHor(buff,0,Arana);
	  ObjVer(buff,1,Pelota);
	  ObjHor1(buff,2,MomDe,MomIz);
		SpritePrincipal(buff);
	
		if (Spy>=112) PasaPantalla(19,Spx,0);
	}
	
	void drawPantalla19(Graphics buff)
	{
		Gota(buff,15,0); 
		Gota(buff,15,1); 
		ObjHor(buff,2,Tabla);
		SpritePrincipal(buff);
	
		if (Spy>=112) PasaPantalla(20,Spx,0);
	}
	
	void drawPantalla20(Graphics buff)
	{
		ObjHor(buff,0,Cosa); 
		ObjVer(buff,1,Aro); 
		Gota(buff,15,2);
		SpritePrincipal(buff);
	
		if (Spy>=112) PasaPantalla(21,Spx,0);
	    if (Spx>=244 && Spy==96) ElTesoro(Spx,Spy,29,10,1,1,i_ColorPuerta,9,false,true);
	}

	void drawPantalla21(Graphics buff)
	{
		Gota(buff,15,0); 
		ObjHor1(buff,1,MomDe,MomIz);
		ObjVer(buff,2,Tabla);
		SpritePrincipal(buff);
	
		if (Spy>=112) PasaPantalla(22,Spx,0);
		if (Spx>=270) PasaPantalla(23,30,104);
		ElTesoro(70,96,28,10,3,3,1,10,true,false);
	}
	
	void drawPantalla22(Graphics buff)
	{
		Gota(buff,15,0); 
		ObjHor(buff,1,Arana); 
		ObjHor(buff,2,Arana);
		SpritePrincipal(buff);
	
		if (Spx==78 && Spy==104) PasaPantalla(19,70,32);
	}
	
	void drawPantalla23(Graphics buff)
	{
		Gota(buff,60,0);
	  ObjHor(buff,1,Bola); 
		ObjHor(buff,2,Tabla); 
		SpritePrincipal(buff);
	
		if (Spx>=270) PasaPantalla(24,32,Spy);
	    if (Spx<30) Spx=30;
	}
	
	void drawPantalla24(Graphics buff)
	{
		ObjHor1(buff,0,SerDe,SerIz);
		ObjVer(buff,1,Rayo);
	  ObjHor1(buff,2,SerDe,SerIz);
		SpritePrincipal(buff);
		
		if (Spx<=30) PasaPantalla(23,268,Spy);
	    if (Spx>=270) PasaPantalla(25,32,Spy);
	}
	
	void drawPantalla25(Graphics buff)
	{
		Gota(buff,15,2); 
		ObjVer(buff,1,Flecha);
		Gota(buff,60,0);	
		SpritePrincipal(buff);
	
	    if (Spx<=30) PasaPantalla(24,268,Spy);
	    if (Spx>=270) PasaPantalla(28,32,Spy);               
	
		if (Spx==118 && Spy==56) PasaPantalla(26,30,16);
		if (Spx==190 && Spy<80) ElTesoro(Spx,Spy,18,9,1,1,i_ColorPuerta,11,false,true);
	}
	
	void drawPantalla26(Graphics buff)
	{
		Gota(buff,15,2); 
		ObjHor(buff,1,Pelota); 
		Gota(buff,60,0);
		SpritePrincipal(buff);
	
		if (Spy<0) PasaPantalla(27,Spx,110);
		if (Spy>=112) PasaPantalla(29,Spx,0);
		ElTesoro(54,96,20,11,3,3,1,12,true,false);
	}
	
	void drawPantalla27(Graphics buff)
	{
		ObjVer(buff,0,Arana); 
		ObjHor(buff,1,Cosa); 
		Gota(buff,15,2);
		SpritePrincipal(buff);
	
		if (Spy>=112) PasaPantalla(26,Spx,0);
	    if (Spy<0) PasaPantalla(28,Spx,110);
	}
	
	void drawPantalla28(Graphics buff)
	{
		ObjVer(buff,0,Arana); 
		ObjHor(buff,1,Bola); 
		ObjVer(buff,2,Pelota);
		SpritePrincipal(buff);
	
		if (Spx<=30) PasaPantalla(25,268,Spy);
	    if (Spy>=112) PasaPantalla(27,Spx,0);
	}
	
	void drawPantalla29(Graphics buff)
	{	
		Gota(buff,60,0); 
		ObjHor(buff,1,Flecha); 
		ObjHor(buff,2,Aro);
		SpritePrincipal(buff);
	
		buff.drawImage(miScreen,30,72,180,80,0,72,150,80,null);
	
		if (Spy>110) PasaPantalla(30,Spx,0);
	  ElTesoro(46,56,0,7,1,1,394,13,false,true);
	}
	
	void drawPantalla30(Graphics buff)
	{
		ObjHor1(buff,0,MomDe,MomIz); 
		ObjVer1(buff,1,PezDo,PezUp);
		Gota(buff,15,2);
		SpritePrincipal(buff);
	
		buff.drawImage(miScreen,30,112,285,128,0,112,255,128,null);
	
		if (Spx<=30) PasaPantalla(31,268,Spy);
	}

	void drawPantalla31(Graphics buff)
	{
		Gota(buff,15,0); 
		ObjVer1(buff,1,PezDo,PezUp); 
		ObjVer(buff,2,Pelota);
		SpritePrincipal(buff);
	
		buff.drawImage(miScreen,30,112,285,128,0,112,255,128,null);
	
		if (Spx>=270) PasaPantalla(30,32,Spy);
	    if (Spx<=30) PasaPantalla(32,268,Spy);
	}
	
	void drawPantalla32(Graphics buff)
	{
		ObjVer1(buff,0,PezDo,PezUp); 
		ObjVer1(buff,1,PezDo,PezUp);
	  ObjVer1(buff,2,PezDo,PezUp);
		SpritePrincipal(buff);
	
		buff.drawImage(miScreen,30,112,285,128,0,112,255,128,null);
	
		if (Spx>=270) PasaPantalla(31,32,Spy);
		if (Spx<=30) PasaPantalla(33,268,Spy);
	}
	
	void drawPantalla33(Graphics buff)
	{
		ObjVer(buff,0,Arana); 
		ObjVer1(buff,1,PezDo,PezUp); 
		ObjVer(buff,2,Pelota);
		SpritePrincipal(buff);
		
		buff.drawImage(miScreen,30,112,285,128,0,112,255,128,null);
	
		if (Spx>=270) PasaPantalla(32,32,Spy);
	  if (Spx<=30) PasaPantalla(34,268,Spy);
	}
	
	void drawPantalla34(Graphics buff)
	{
		Gota(buff,15,0); 
		ObjVer(buff,1,Arana); 
		ObjHor1(buff,2,SerDe,SerIz);
		SpritePrincipal(buff);
	
		if (Spx>=270) PasaPantalla(33,32,Spy);
	  if (Spx<30) Spx=30;
	  if (Spy<0) PasaPantalla(35,Spx,110);
	}
	
	void drawPantalla35(Graphics buff)
	{
		ObjHor1(buff,0,MomDe,MomIz); 
		Gota(buff,15,1); 
		Horizontal(buff,2,Lanza);
		SpritePrincipal(buff);
	
		if (Spy<0) PasaPantalla(36,Spx,110);
		if (Spy>=112) PasaPantalla(34,Spx,0);
	}
	
	protected int g_pulsado=-1;
	void drawPantalla36(Graphics buff)
	{
		Gota(buff,15,0); 
		ObjHor1(buff,1,SerDe,SerIz); 
		ObjHor(buff,2,Aro);
		SpritePrincipal(buff);
	
		if (Spy>=112) PasaPantalla(35,Spx,0);
		if ((g_pulsado==i_ColorPuerta) || (Spx<72 && Spy<42))
		{
			g_pulsado=i_ColorPuerta;
			ElTesoro(Spx,Spy,9,2,5,5,1,14,true,false);
		}
		
		if (Spx>142 && Spy==40) 
		{
			if (QueHay(Spx+8,Spy-2)==i_ColorPuerta) PasaPantalla(37,46,0);
			else PasaPantalla(10,206,80);
		}
	}
	
	void drawPantalla37(Graphics buff)
	{
		Gota(buff,15,0); 
		ObjHor(buff,1,Cosa);
	
		// Pelota que rebota.
		PutSprite(buff,Bola[Ene[2].Im],Ene[2].X,Ene[2].Y);
	    Ene[2].Im++;
		if (Bola[Ene[2].Im]==0) Ene[2].Im=1;
		Ene[2].X+=Ene[2].V;
	    Ene[2].Y+=Ene[2].P0;
	    if (Ene[2].X<=78 || Ene[2].X>=118) Ene[2].V=-Ene[2].V;
	    if (Ene[2].Y>=64 || Ene[2].Y<=16) Ene[2].P0=-Ene[2].P0;
	
		SpritePrincipal(buff);
	
		if (Spy<0) Spy=0;
		if (Spx>=174 && Spx<=190 && Spy==72 && i_Tesoros==16) 
		{
			ElTesoro(Spx,Spy,19,12,1,1,1,16,true,false);
		}
		if (Spx>245 && Spy==80) ElTesoro(Spx,Spy,28,12,1,1,i_ColorPuerta,15,false,true);
	
		if (i_Tesoros==17) PasaPantalla(38,54,40);
	}
	
	void drawPantalla38(Graphics buff)
	{
		Gota(buff,15,0); 
		ObjHor(buff,1,Arana); 
		ObjHor(buff,2,Arana);
		SpritePrincipal(buff);
	
		if (Spx>=270) PasaPantalla(39,32,Spy);
	}
	
	void drawPantalla39(Graphics buff)
	{
		ObjVer(buff,0,Rayo); 
		ObjVer(buff,1,Rayo); 
		ObjVer(buff,2,Rayo);
		SpritePrincipal(buff);
	
		if (Spx>=270) PasaPantalla(40,32,Spy);
		if (Spx<=30) PasaPantalla(38,268,Spy);
	}
	
	void drawPantalla40(Graphics buff)
	{
		ObjVer(buff,0,Pelota); 
		ObjHor(buff,1,Cosa); 
		ObjVer(buff,2,Arana);
		SpritePrincipal(buff);
	
		if (Spx<=30) PasaPantalla(39,268,Spy);
	  if (Spy>=112) PasaPantalla(41,Spx,0);
	}
	
	void drawPantalla41(Graphics buff)
	{
		ObjHor(buff,0,Arana); 
		ObjHor(buff,1,Arana); 
		ObjHor(buff,2,Arana);
		SpritePrincipal(buff);
	
		if (Spy>=112) PasaPantalla(42,Spx,0);
		if (Spy<0) PasaPantalla(40,Spx,110);
	}
	
	void drawPantalla42(Graphics buff)
	{
		ObjVer(buff,0,Bola); 
		Gota(buff,15,1); 
		Gota(buff,60,2);
		SpritePrincipal(buff);
	
		if (Spx<=30) PasaPantalla(43,268,Spy);
		if (Spy<2) PasaPantalla(41,Spx,112);
		if (Spy>=112) PasaPantalla(31,Spx,0);
		
	}
	
	void drawPantalla43(Graphics buff)
	{
		if (i_Tesoros<19)
		{
			ObjHor(buff,0,Rayo); 
			ObjHor1(buff,1,SerDe,SerIz); 
			Gota(buff,15,2);
	
			if (Spx>=270) PasaPantalla(42,32,Spy);
			if (Spy>=112) PasaPantalla(31,Spx,0);
			if (Spx<=30) PasaPantalla(44,268,Spy);
	    
			ElTesoro(198,88,20,0,3,12,1,18,true,false);
		}
		else
		{
			PasaPantalla(45,0,0);
			return;		
		}
			
		SpritePrincipal(buff);	
	}
	
	void drawPantalla44(Graphics buff)
	{
		Gota(buff,15,0); 
		ObjHor1(buff,1,MomDe,MomIz); 
		ObjVer(buff,2,Arana);
		SpritePrincipal(buff);
	
		if (Spx>=270) PasaPantalla(43,32,Spy);
	  ElTesoro(46,80,2,8,1,1,i_ColorPuerta,17,true,false);
	}
	
	void drawFinal(Graphics buff)
	{
		miFont.drawText("ENHORA BUENA.",-1,40);
		miFont.drawText("GRACIAS A TI JONHY HA RECUPERADO",-1,50);
		miFont.drawText("SU VERDADERO CUERPO Y HA SALIDO",-1,60);
		miFont.drawText("SANO Y SALVO DE LA PIRAMIDE.",-1,70);
		miFont.drawText("QUEDAS INVITADO A UNA COPA EN",-1,80);
		miFont.drawText("EL ICE CLUB.",-1,90);
	}

	// **********************************
	// 	 MANEJADOR DEL SPRITE PRINCIPAL
	// **********************************

	static int g_Imagen=0;
	static int A0,A1,A2,A3;
	static int g_estado=0;
	static int g_max_altura,g_altura;
	
	void SpritePrincipal(Graphics buff)
	{
		if (i_Vidas<0) 
		{
			drawGameOver(buff);
			return;
		}
	
		if (g_estado<6 && Colisionado()) g_estado=6;
	
		if (g_estado>0) switch (g_estado)
		{
		case 1:	// SALTANDO A LA DERECHA
	
			PutSprite(buff,5,Spx,Spy);
			A2=QueHay(Spx,Spy-2);
			A3=QueHay(Spx+15,Spy-2);
			if ((A2==1 || A2>397) && (A3==1 || A3>397)) Spy-=DesplazaY;
	     
			A0=QueHay(Spx+17,Spy);
			A1=QueHay(Spx+17,Spy+15);
			if ((A1==1 || A1>397) && (A0==1 || A0>397)) Spx+=DesplazaX;
			
			// --COUNT UP
			g_altura++;
			if (g_altura<1 || g_altura>g_max_altura) g_altura=1;
			// --Count UP
			
			if (g_altura==g_max_altura) 
			{
				g_estado=2; // CAER A LA DERECHA
			}
			return;
	
		case 2: // CAYENDO A LA DERECHA
	
			A0=QueHay(Spx+17,Spy);
			A1=QueHay(Spx+17,Spy+15);
			if ((A1==1 || A1>397) && (A0==1 || A0>397)) Spx+=DesplazaX;
			if (!HaySuelo()) Spy+=DesplazaY; else g_estado=0;
			
			PutSprite(buff,5,Spx,Spy);
			return;
	
		case 3:	// SALTANDO A LA IZQUIERDA
	
			PutSprite(buff,6,Spx,Spy);
			A2=QueHay(Spx,Spy-2);
			A3=QueHay(Spx+15,Spy-2);
			if ((A2==1 || A2>397) && (A3==1 || A3>397)) Spy-=DesplazaY;
	     
			A0=QueHay(Spx-2,Spy);
			A1=QueHay(Spx-2,Spy+15);
			if ((A1==1 || A1>397) && (A0==1 || A0>397)) Spx-=DesplazaX;
			
			// --COUNT UP
			g_altura++;
			if (g_altura<1 || g_altura>g_max_altura) g_altura=1;
			// --Count UP
			
			if (g_altura==g_max_altura) g_estado=4; // CAER A LA IZQUIERDA
			return;
	
		case 4: // CAYENDO A LA IZQUIERDA
	
			A0=QueHay(Spx-2,Spy);
			A1=QueHay(Spx-2,Spy+15);
			if ((A1==1 || A1>397) && (A0==1 || A0>397)) Spx-=DesplazaX;
			if (!HaySuelo()) Spy+=DesplazaY; else g_estado=0;
			
			PutSprite(buff,6,Spx,Spy);
			return;
	
		case 5:	// SALTANDO HACIA ARRIBA
	
			PutSprite(buff,3,Spx,Spy);
			A0=QueHay(Spx,Spy-2);
			A1=QueHay(Spx+15,Spy-2);
			if ((A1==1 || A1>397) && (A0==1 || A0>397)) Spy-=DesplazaY;

			// --COUNT UP
			g_altura++;
			if (g_altura<1 || g_altura>g_max_altura) g_altura=1;
			// --Count UP
			
			if (g_altura==g_max_altura) g_estado=0;
			return;
	
		case 6: // EL PERSONAJE HA COLISIONADO (Busca el Suelo)
	
			PutSprite(buff,72,Spx,Spy);
			if (!HaySuelo() && Spy<110) Spy+=DesplazaY; else g_estado=7;
			return;
		
		case 7: // EL PERSONAJE HA COLISIONADO (Sacando Lapida)
	
			// Count Up
			A0++;
			if (A0<1 || A0>4) A0=1;
			// Count Up
			
			if (A0==4) { 
				// Count Down
				g_Imagen--;
				if (g_Imagen<80 || g_Imagen>87) g_Imagen=87;
			}
			
			PutSprite(buff,g_Imagen,Spx,Spy);		
			if (g_Imagen==80) { A0=0; g_estado=8;}
			return;
	
		case 8: // EL PERSONAJE HA COLISIONADO (Manteniendo la lpida)
	
			// Count Up
			A0++;
			if (A0<1 || A0>64) A0=1;
			// Count Up
			
			PutSprite(buff,g_Imagen,Spx,Spy);		
			
			if (A0==10) {;
				i_Vidas--;
				Spx=MSpx;
				Spy=MSpy;
				g_estado=0;
			}
			return;
		}
	
		if (HaySuelo())
		{	
			if (ib_salto_largo)
			{	
				g_altura=0; g_max_altura=18;
				if (ib_derecha) g_estado=1;			// Salto Derecha
				else if (ib_izquierda) g_estado=3;	// Salto Izquierda
				else g_estado=5;						// Salto Arriba
	
				// Count Up
				g_Imagen++;
				if (g_Imagen<0 || g_Imagen>299) g_Imagen=0;
				// Count Up
				
				PutSprite(buff,Jonhy[g_Imagen / 50],Spx,Spy);    
				return;
			}
	
			if (ib_salto_corto)
			{
				g_altura=0; g_max_altura=10;
				if (ib_derecha) g_estado=1;			// Salto Derecha
				else if (ib_izquierda) g_estado=3;	// Salto Izquierda
				else g_estado=5;						// Salto Arriba
		
				// Count Up
				g_Imagen++;
				if (g_Imagen<0 || g_Imagen>299) g_Imagen=0;
				// Count Up
				
				PutSprite(buff,Jonhy[g_Imagen / 50],Spx,Spy);    
				return;
			}
			
			// Si esta pulsado para la derecha..
			if (ib_derecha)
			{
			  // Count Up
			  g_Imagen++;
			  if (g_Imagen<7 || g_Imagen>10) g_Imagen=7;
			  // Count Up
			  
			  PutSprite(buff,g_Imagen,Spx,Spy);
			  A1=QueHay(Spx+17,Spy+15); 
			  A0=QueHay(Spx+17,Spy);
			  if ( (A1==1 || A1>397) && (A0==1 || A0>397 )) Spx+=DesplazaX;
			  return;
			}
	
			// Si esta pulsado para la izquierda..
			if (ib_izquierda)
			{
			  // Count Down
			  g_Imagen--;
			  if (g_Imagen<11 || g_Imagen>14) g_Imagen=14;
			  // Count Down
			  
			  PutSprite(buff,g_Imagen,Spx,Spy);
			  A1=QueHay(Spx-2,Spy+15); 
			  A0=QueHay(Spx-2,Spy);
			  if ( (A1==1 || A1>397) && (A0==1 || A0>397 )) Spx-=DesplazaX;
			  return;
			}
		}
		else Spy+=DesplazaY;
	
		// Si no se esta moviendo, hace miraditas.
		g_Imagen++;
		if (g_Imagen<0 || g_Imagen>299) g_Imagen=0;
		PutSprite(buff,Jonhy[g_Imagen / 50],Spx,Spy);	    
	}	
	
	// ***********************************
	//      MANEJADORES DE EVENTOS
	// ***********************************
	
	public boolean handleEvent(Event evt)
	{
		/*
		if ((evt.id == Event.KEY_PRESS || evt.id == Event.KEY_ACTION) && (evt.key=='1'))
		{
			i_PantallaActual++;
			if (i_PantallaActual>44) i_PantallaActual=0;
			PasaPantalla(i_PantallaActual+1,Spx,Spy);
			return true;
		}
		*/
		
		if (evt.id == Event.KEY_PRESS)
		{
			if      (maGame.i_Teclas[0][0] == evt.key) ib_derecha = true;
			else if (maGame.i_Teclas[1][0] == evt.key) ib_izquierda = true;
			else if (maGame.i_Teclas[2][0] == evt.key) ib_salto_largo = true;
			else if (maGame.i_Teclas[3][0] == evt.key) ib_salto_corto = true;
			else if (maGame.i_Teclas[4][0] == evt.key) i_Estado=1000; // Abortar.
		}
		else if (evt.id == Event.KEY_RELEASE)
		{
			if      (maGame.i_Teclas[0][0] == evt.key) ib_derecha = false;
			else if (maGame.i_Teclas[1][0] == evt.key) ib_izquierda = false;
			else if (maGame.i_Teclas[2][0] == evt.key) ib_salto_largo = false;
			else if (maGame.i_Teclas[3][0] == evt.key) ib_salto_corto = false;
		}
					
		return false;
	}
	
	// **********************************
	// 			OTROS METODOS DE CONTROL
	// **********************************
	
	void drawGameOver(Graphics g) 
	{		
		miFont1.drawText(g,"GAME OVER",-1,64,i_seno);
	
		// Rotamos el Array de Seno.
		System.arraycopy(i_seno,0,i_senobuff,0,5);		
		System.arraycopy(i_seno,5,i_seno,0,315);
		System.arraycopy(i_senobuff,0,i_seno,315,5);		
	}
	
	protected boolean HaySuelo()
	{
	 int B1,B2; 
	 B1=QueHay(Spx,Spy+17); B2=QueHay(Spx+15,Spy+17);
	 return !((B1==1 || B1>397) && (B2==1 || B2>397));
	}
	
	protected int QueHay(int x,int y)
	{
	 x=(x-22)/8;
	 y/=8;
	 return Mapeado[i_PantallaActual*512+y*32+x-1];
	}
	
	boolean Colisionado()
	{
		int i;
		for (i=0;i<3;i++)
		{
	     if ( (Spx+6>=Ene[i].X  && Spx+6<=Ene[i].X+15 &&
			   Spy+4>=Ene[i].Y  && Spy+4<=Ene[i].Y+15) ||
	          (Spx+9>=Ene[i].X  && Spx+9<=Ene[i].X+15 &&
	           Spy+12>=Ene[i].Y && Spy+12<=Ene[i].Y+15) ) return true;
		}
		
		i=QueHay(Spx+8,Spy+15);
	    if (i>397 && i<401) return true;
	
		return false;
	}

	protected void MeteTesoro(int tile1,int tile2,int tile3,int tile4)
	{
		if (BuffTesoros.Tesoros==0) 
		{
			BuffTesoros.Tiles1[0]=tile1;
			BuffTesoros.Tiles1[1]=tile2;
			BuffTesoros.Tiles1[2]=tile3;
			BuffTesoros.Tiles1[3]=tile4;
		}
		else
		{
			BuffTesoros.Tiles2[0]=tile1;
			BuffTesoros.Tiles2[1]=tile2;
			BuffTesoros.Tiles2[2]=tile3;
			BuffTesoros.Tiles2[3]=tile4;
		}		
		BuffTesoros.Tesoros++;
	}

	protected void SacaTesoro(boolean t)
	{
		if (BuffTesoros.Tesoros==0) return;
		if (BuffTesoros.Tesoros==1) 
		{
			BuffTesoros.Tesoros--;
			return;
		}
		if (!t) for (int i=0;i<4;i++) BuffTesoros.Tiles1[i]=BuffTesoros.Tiles2[i];
		BuffTesoros.Tesoros--;
	}

	int ElTesoro_dist;
	int ElTesoro_estado=0;
	Rectangle ElTesoro_lRect = new Rectangle();
	Rectangle ElTesoro_lRect1 = new Rectangle();
	Rectangle ElTesoro_lRect2 = new Rectangle();
	 
	protected void ElTesoro(int X,int Y,int X1,int Y1,int AX,int AY,int V,int AT,boolean Sc,boolean coger)
	{
	 
	 if (i_Tesoros>AT ) return;
	
	 switch (ElTesoro_estado)
	 {
		 case 0:
			if (Spx==X && Spy==Y && i_Tesoros==AT) 
			{
				ElTesoro_lRect.x = X1*8;
				ElTesoro_lRect.y = Y1*8;
				ElTesoro_lRect.width = ElTesoro_lRect.x + (AX+1)*8;
				ElTesoro_lRect.height = ElTesoro_lRect.y + (AY+1)*8;
	
				ElTesoro_lRect1.setBounds(ElTesoro_lRect);
				ElTesoro_lRect2.setBounds(ElTesoro_lRect);
				
				ElTesoro_lRect.y++;
				ElTesoro_lRect1.height--;
				ElTesoro_lRect2.y=ElTesoro_lRect2.height-1;
	
				ElTesoro_dist = ElTesoro_lRect.height - ElTesoro_lRect.y;
				
				ElTesoro_lRect2.width = (ElTesoro_lRect2.width - ElTesoro_lRect2.x);
				ElTesoro_lRect2.height = (ElTesoro_lRect2.height - ElTesoro_lRect2.y);
					
				if (Sc) SuenaPuerta(); else SuenaCoger();
	
				// Rectificadores de los trocitos a coger.
				//
				switch (i_PantallaActual+1)
				{
				 case 6:
					 X1=26;Y1=4;
					 break;
				 case 8:
					 X1=24; Y1=9;
					 break;
				 case 12:
					 X1=23; Y1=2;
					 break;
				 case 16:
					 X1=19; Y1=2;
					 break;
				 case 20:
					 X1=29; Y1=10;
					 break;
				 case 25:
					 X1=18; Y1=9;
					 break;
				}
	
				if (coger)
				{
					MeteTesoro(
						Mapeado[i_PantallaActual*512+Y1*32+X1],
						Mapeado[i_PantallaActual*512+Y1*32+X1+1],
						Mapeado[i_PantallaActual*512+(Y1+1)*32+X1],
						Mapeado[i_PantallaActual*512+(Y1+1)*32+X1+1]);
				}
				else 
				{
					switch (i_PantallaActual+1)
					{
					case 17:
					case 21:
					case 26:
						SacaTesoro(false);
						break;
					default:
						SacaTesoro(true);
					}
				}
	
				ElTesoro_estado++;
			}				
			break;
	
		 case 1:
	 		if (Sc && ElTesoro_dist>0) 
			{
				miScreen.getGraphics().drawImage(miScreen,
					ElTesoro_lRect1.x,ElTesoro_lRect1.y,ElTesoro_lRect1.width,ElTesoro_lRect1.height,
					ElTesoro_lRect.x ,ElTesoro_lRect.y ,ElTesoro_lRect.width ,ElTesoro_lRect.height,null);
				miScreen.getGraphics().fillRect(ElTesoro_lRect2.x,ElTesoro_lRect2.y,ElTesoro_lRect2.width,ElTesoro_lRect2.height);
				ElTesoro_dist--;
			}
			else
			{
			 if (V>0) RellenaMapa(X1,Y1,AX+1,AY+1,V,-1);
			 DrawScreen(miScreen.getGraphics(),i_PantallaActual);
			 i_Tesoros=AT+1;
			 ElTesoro_estado=0;
			}
	 }
	
	}
	  
	
	  
} // fin de la clase.