import java.awt.*;
import ma.game.*;

public class TPresentacion extends TEscenario
{	
  protected Image miPanel;
  protected Image miLogo1;
  protected Image miLogo2;
  protected TFont miFont;
  protected Rectangle Zonas[];
  protected int i_pos,iZonas;
  protected int i_Escenario=0;
  protected int i_seno[] = new int[320];
  protected int i_senobuff[] = new int[5];
  
  String i_texto[]= 
	{
		"ABU SIMBEL PROFANATION",
		"",
		"VERSION SPECTRUM POR VICTOR RUIZ",
		"VERSION AMIGA Y PC POR MA SOFT",
		"",
		"DESCUBRE EL SECRETO DE ABU SIMBEL",
		"PARA LIBERAR A JOHNY JONES DEL MALEFICIO",
		"Y RECUERDA LAS LEYENDAS QUE SOBRE EL",
		"TEMPLO DE ABU SIMBEL NOS DEJARON LOS",
		"ANTIGUOS LIBROS",
		"",
		"ESPERA CALCULA Y PIENSA ANTES DE ACTUAR",
		"DICHOS EGIPCIOS CAP XII",
		"",
		"EL DIAMANTE TE MOSTRARA EL CAMINO",
		"TEMPLOS PERDIDOS PAG8 V23"
	};  
  
	public void init()
	{
		// Cargamos los grficos de la presentacion.
		
		String ls_path = "pics/";
		
		// Establecemos color de fondo.
    maGame.i_gameCanvas.setSurfaceBackground(new Color(0,0,0));
    maGame.i_gameCanvas.clear();	
	  
	  // Creamos el Font
	  miFont = new TFont(ls_path+"Fonts.gif",8,8,"ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789()>,");
    	  
		// Esperamos a que se carguen todas las imagenes.
    maGame.getTracker().Reset();
	  miPanel = maGame.LoadImage(ls_path+"Panel.gif");
    miLogo2 = maGame.LoadImage(ls_path+"Logo.gif");
    miLogo1 = maGame.LoadImage(ls_path+"Presen.gif");
    maGame.getTracker().AddWaitImage(miPanel);
	  maGame.getTracker().AddWaitImage(miLogo1);
    maGame.getTracker().AddWaitImage(miLogo2);    
    maGame.getTracker().WaitImages();
		
	  maGame.setGameSpeed(100);
	  Zonas =  new Rectangle[16];
	  for (int i=0;i<16;i++) Zonas[i]=new Rectangle();
	  
		super.init();	  
	}	
	
	public void draw(Graphics g)
	{
    maGame.i_gameCanvas.clear();	
    switch (i_Escenario)
		{
			case 0:
				drawPresentacion(g);
				break;
				
			case 1:
				drawMenu(g);
				break;
		}
	}
  
  public void drawPresentacion(Graphics g)
  {
      int z,j,i;
      Rectangle lRect=new Rectangle();
      
      switch (i_Estado)
      {
      case 0:
      case 2:
        z=0;
        for (j=0;j<2;j++)
        for (i=0;i<8;i++)
        {
          Zonas[z].height= j*100+50;
          Zonas[z].y=j*100+50;
          
          if (j%2==0)
          {
            Zonas[z].x=i*40;
            Zonas[z].width = i*40+40;
          }
          else
          {
            Zonas[z].x=280-i*40;
            Zonas[z].width = 280-i*40+40;
          }
          
          z++;
        }
      
        iZonas=0;
        i_Estado++;
        i_pos=0;
        break;
      
      case 1:
      case 3:
        for (j=0;j<2;j++)
        for (i=0;i<8;i++)
        {
          if (j%2==0) z=j*8+i;
          else z=j*8+7-i;
      
          if (z<=iZonas)
          {
           if ((Zonas[z].height - Zonas[z].y)<100 && (i_pos%2==0))
           {
            Zonas[z].height++;
            Zonas[z].y--;
           }
           lRect.x = i*40;
           lRect.y= j*100;
           lRect.width = lRect.x + 40;
           lRect.height = lRect.y + 100;
           if (i_Estado==1)
            g.drawImage(miLogo1,Zonas[z].x,Zonas[z].y,Zonas[z].width,Zonas[z].height,
                        lRect.x,lRect.y,lRect.width,lRect.height,null);
           else
             g.drawImage(miLogo2,Zonas[z].x,Zonas[z].y,Zonas[z].width,Zonas[z].height,
                        lRect.x,lRect.y,lRect.width,lRect.height,null);
           
          }
        }
      
        i_pos++;
        if (i_pos%10==0 && iZonas<15) iZonas++;
        if (i_pos>400) i_Estado++;
        break;
      
      case 4:
        i_Estado=0;
      }
  }
  
  void drawMenu(Graphics buff)
	{
		switch (i_Estado)
		{		
		case 0:
				
				double delta=(1*3.14)/320;
				double inc=0;
				
				// Inicializamos la tabla de Seno.
				for (int i=0;i<320;i++)
				{
					i_seno[i]=(int)(8*Math.sin(inc));
					inc+=delta;
				}
				
				i_pos = 0;
				i_Estado++;
				
		case 1:
			// Muestra el Texto en la Pantalla.
			
			for(int i=0;i<16;i++)
			{
				miFont.drawText(buff,i_texto[i],-1,130+i*10-i_pos,i_seno);
			}
			i_pos+=4;
			
			if (i_pos==300) i_pos=0;
			break;
		
		case 2:		
			miFont.drawText(buff,"1> REDEFINIR TECLADO",-1,30,i_seno);
			miFont.drawText(buff,"2> JUGAR",-1,40,i_seno);
			miFont.drawText(buff,"3> HISTORIA",-1,50,i_seno);
			break;
		
		case 3:
			// Leer tecla derecha.
			miFont.drawText(buff,"PULSE TECLA DERECHA",-1,70,i_seno);
			break;
		case 4:
			// Leer tecla izquierda.
			miFont.drawText(buff,"PULSE TECLA IZQUIERDA",-1,70,i_seno);
			break;
		case 5:
			// Leer tecla salto largo.
			miFont.drawText(buff,"PULSE TECLA SALTO LARGO",-1,70,i_seno);
			break;
		case 6:
			// Leer tecla salto corto.
			miFont.drawText(buff,"PULSE TECLA SALTO CORTO",-1,70,i_seno);
			break;		
		case 7:
			// Leer tecla abortar.
			miFont.drawText(buff,"PULSE TECLA PARA ABORTAR",-1,70,i_seno);
			break;		

		}
		
		buff.drawImage(miPanel,0,129,null);
		
		// Rotamos el Array de Seno.
		System.arraycopy(i_seno,0,i_senobuff,0,5);		
		System.arraycopy(i_seno,5,i_seno,0,315);
		System.arraycopy(i_senobuff,0,i_seno,315,5);		
		
		if (i_Estado==100)
		{
			maGame.setStartClass("TJuego");
			maGame.startClass();
		}
													
	}

	public boolean handleEvent(Event evt)
	{
		switch (i_Escenario)
		{
			case 0:
				if (evt.id == Event.KEY_PRESS || evt.id == Event.KEY_ACTION)
				{
					i_Estado=0;
					i_Escenario=1;
					return true;
				}
				break;
				
			case 1:
				if (evt.id == Event.KEY_PRESS || evt.id == Event.KEY_ACTION)
				{
					switch (i_Estado)
					{
						case 1:
							i_Estado++;
							break;
					
						case 2:
									switch (evt.key)
									{
										case '1':
											i_Estado = 3;	// Redefinir Teclado
											break;
						
										case '2':
											i_Estado = 100;
											break;	// Jugar
						
										case '3':
											i_Estado = 0;	// Historia
											break;
									}
							break;
						
						case 3:	// Coger tecla derecha.
							maGame.i_Teclas[0][0] = evt.key;
							i_Estado++;
							break;

						case 4:	// Coger tecla izquierda.
							maGame.i_Teclas[1][0] = evt.key;
							i_Estado++;
							break;

						case 5:	// Coger tecla salto largo.
							maGame.i_Teclas[2][0] = evt.key;
							i_Estado++;
							break;

						case 6:	// Coger tecla salto corto.
							maGame.i_Teclas[3][0] = evt.key;
							i_Estado++;
							break;

						case 7:	// Coger tecla abortar.
							maGame.i_Teclas[4][0] = evt.key;
							i_Estado=2;
							break;
					} // Fin Switch
						
				}// Fin del IF
				break; // Del Case 1
				
		} // Fin del Switch	
		return false;
	}
		
} // Fin de la Clase TPresentacion