package ma.game;

// Esta clase implementa un tipo de letra
// y las rutinas basicas necesarias.

import java.util.Vector;
import java.awt.*;

import ma.game.*;

public class TFont
{
	public static TGame maGame;
  protected Image bitmapFont=null;

	protected String i_MapFonts = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ:.()*<>";
	protected Vector i_Fonts = new Vector();
	protected int width=0,height=0;
	
	// Constructor.
	//
	// magame -> Applet de tipo MA_Game, necesario para cargar imagenes.
	// 
	public TFont(String fontdir)
	{
		int li_i;
		String ls_file,ls_letra;
		Image img=null;
		TImageTracker ITrack = maGame.getTracker();
		
		// Cargamos los fonts.
		for(li_i=0;li_i<i_MapFonts.length();li_i++)
		{
			ls_letra = "" + i_MapFonts.charAt(li_i);
			
			if (ls_letra.equals(":"))
			{
				ls_file = "dots";
			}
			else if (ls_letra.equals("."))
			{
				ls_file = "dot";
			}
			else if (ls_letra.equals("("))
			{
				ls_file = "parent1";
			}
			else if (ls_letra.equals(")"))
			{
				ls_file = "parent2";
			}
			else if (ls_letra.equals("*"))
			{
				ls_file = "asterisk";
			}
			else if (ls_letra.equals("<"))
			{
				ls_file = "less";
			}
			else if (ls_letra.equals(">"))
			{
				ls_file = "more";
			}
			else
			{
				ls_file = ls_letra;
			}
			
			ls_file = fontdir + "/f_" + ls_file + ".gif";
			
			img = maGame.LoadImage(ls_file);
			i_Fonts.addElement(img);
			ITrack.AddWaitImage(img);
		}
		
		// Esperamos a que se carguen todas las imagenes.
		ITrack.WaitImages();
				
		if (img!=null)
		{
		 width = img.getWidth(maGame) + 1;
		 height = img.getHeight(maGame) + 1;
		}			
	}
	
  // Constructor a partir de un bitmap de Fonts.
  //
  // magame -> Applet de tipo MA_Game, necesario para cargar imagenes.
  // 
  public TFont(String imagen,int w,int h,String chars)
  {
    TImageTracker ITrack = maGame.getTracker();
    
    bitmapFont = maGame.LoadImage(imagen);
    ITrack.AddWaitImage(bitmapFont);
     
    // Esperamos a que se carguen todas las imagenes.
    ITrack.WaitImages();
        
    width = w;
    height= h;
    i_MapFonts = chars;
  }
  
  
	// Dibuja un texto en el buffer del juego.
	//
	public void drawText(String text,int x,int y)
	{
		drawText(maGame.getSurfaceGraphics(),text,x,y,null);
	}
	 
	public void drawText(Graphics g,String text,int x, int y,int yoff[])
	{
		int i,j;
		int ix=x,iy;
		Image img;
		
		if (x==-1)
		{
			Rectangle r = maGame.i_gameCanvas.bounds();
			ix = (r.width - text.length()*width) / 2;
		}				
		
	  if (bitmapFont==null)
  	{
      for (i=0;i<text.length();i++)
      {
        j = i_MapFonts.indexOf(text.charAt(i));
        if (j>=0)
        {
          img = (Image)i_Fonts.elementAt(j);
          if (yoff==null) iy = y; else iy = y + yoff[ix];
          g.drawImage(img,ix,iy,null);
        }
        ix+=width;
      }
  	}
	  else
  	{
  	  for (i=0;i<text.length();i++)
      {
        j = i_MapFonts.indexOf(text.charAt(i));
        if (j>=0)
        {
					if (yoff==null) iy = y; else iy = y + yoff[ix];
					g.drawImage(bitmapFont,ix,iy,ix+width,iy+height,j*width,0,j*width+width,height,null);
        }
        ix+=width;
      }
  	}  
	  
	}
}
	
	