package ma.game;

import java.awt.*;
import ma.game.*;

// Esta clase implementa un sprite bsico.
//
public class TSprite
{
	// Referencia al juego.
	public static TGame maGame=null;

	public Rectangle pos = new Rectangle();
	public int curFrame=0;
	public boolean detect_collision = false;
	
	protected int minframe=1,maxframe=1;
	
	
	// Constructor.
	//
	// frames -> Numero de frames por fotograma.
	//
	public TSprite(int frames)
	{
		this(frames,false);
	}
	
	public TSprite(int frames,boolean collision)
	{
		maxframe = frames;
		pos.x=0;pos.y=0;
		detect_collision = collision;
	}
	
	// Incrementa el frame e indica cuando
	// debe cambiarse el fotograma.
	//
	public boolean incFrames()
	{
		if ((minframe++)>maxframe)
		{
			minframe=1;
			return true;
		}
		return false;
	}
	
	// Este metodo avanza el sprite
	// devuelve false si ha terminado la ejecucin
	//
	public boolean play()
	{
		return (!finished());
	}
		
		
	// Debe devolver cuando el sprite
	// ha terminado de funcionar.
	//
	public boolean finished()
	{
		return false;
	}
	
	// Este mtodo debe invocarse cuando se
	// elimina el sprite de la cola de sprites en caso
	// de que el sprite tenga que hacer algo.
	//
	public void finish()
	{}
	
	// Este mtodo es incovado cuando se produce
	// la colisin de Este sprite con otro.
	public void onCollision(TSprite S)
	{}
	
	// Si un Sprite ha de dibujarse de forma especial,
	// debe sobreescribir este mtodo y devolver true.
	//
	public boolean selfDraw(Graphics g)
	{return false;}
	
}