package ma.utils;

import java.util.NoSuchElementException;
import java.util.Enumeration;
import ma.utils.TZBufferList;
import ma.utils.TZBufferItem;

public class TZBufferEnumeration implements Enumeration
{
	private TZBufferList miList;
	private boolean ib_up;
	private int ii_pos = 0;
	private int ii_size;
	private TZBufferItem i_Buff[];
	
	// Crea un iterador sobre una TZBufferList indicando
	// si ha de enumerar ascendente o descendente.
	//
	public TZBufferEnumeration(TZBufferList bl,boolean up)
	{
		ib_up = up;
		miList = bl;
		Reset();
	}
		
	// Resetea el Iterador.
	//
	public void Reset()
	{
		ii_size = miList.getCount();
		ii_pos = (ib_up)?0:ii_size-1;
		if (ii_pos<0) ii_pos = 0;
		if (ii_size>0)
		{
		  // i_Buff = new TZBufferItem[ii_size+1];
		  // System.arraycopy(miList.i_Buff,0,i_Buff,0,ii_size-1);
			i_Buff = miList.i_Buff;
		}
	}
	
	// Indica si hay ms elementos.
	//
	public boolean hasMoreElements()
	{
		return ((ib_up )?(ii_pos < ii_size ):(ii_pos>=0)) && (ii_size > 0);
	}
	
	// Da un paso atras en la enumeracin.
	//
	public void back()
	{
		if (ib_up)
		{
			if (ii_pos>0) ii_pos --;
		}
		else
		{
			if (ii_pos<ii_size) ii_pos ++;
		}
	}

	// Devuelve el siguiente elemento.
	//
	public Object nextElement() throws NoSuchElementException
	{
		TZBufferItem l_tzbi;
		
		if (ib_up) 
		{
			if (ii_pos<ii_size)
			{
			 l_tzbi = i_Buff[ii_pos++];	
			}
			else throw new NoSuchElementException();
		}
		else
		{
			if (ii_pos>=0)
			{
			 l_tzbi = i_Buff[ii_pos--];	
			}
			else throw new NoSuchElementException();				
		}
		
		return l_tzbi.item;
	}
}